# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from minknow_api import minion_device_pb2 as minknow__api_dot_minion__device__pb2


class MinionDeviceServiceStub(object):
    """Interface to control MinION (and MinION-like) devices.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.change_settings = channel.unary_unary(
                '/minknow_api.minion_device.MinionDeviceService/change_settings',
                request_serializer=minknow__api_dot_minion__device__pb2.ChangeSettingsRequest.SerializeToString,
                response_deserializer=minknow__api_dot_minion__device__pb2.ChangeSettingsResponse.FromString,
                )
        self.get_settings = channel.unary_unary(
                '/minknow_api.minion_device.MinionDeviceService/get_settings',
                request_serializer=minknow__api_dot_minion__device__pb2.GetSettingsRequest.SerializeToString,
                response_deserializer=minknow__api_dot_minion__device__pb2.GetSettingsResponse.FromString,
                )
        self.get_fan_speed = channel.unary_unary(
                '/minknow_api.minion_device.MinionDeviceService/get_fan_speed',
                request_serializer=minknow__api_dot_minion__device__pb2.GetFanSpeedRequest.SerializeToString,
                response_deserializer=minknow__api_dot_minion__device__pb2.GetFanSpeedResponse.FromString,
                )


class MinionDeviceServiceServicer(object):
    """Interface to control MinION (and MinION-like) devices.
    """

    def change_settings(self, request, context):
        """Change the settings for the active device.

        If you omit a parameter, that setting will not be changed.

        This call is atomic: either all the settings will be applied, or none of them (if there is an
        error).
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def get_settings(self, request, context):
        """Get the current settings for the active device.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def get_fan_speed(self, request, context):
        """Get the rotational rate of the fan cooling the heat-sink. (Not available
        on all MinION platforms.)
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_MinionDeviceServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'change_settings': grpc.unary_unary_rpc_method_handler(
                    servicer.change_settings,
                    request_deserializer=minknow__api_dot_minion__device__pb2.ChangeSettingsRequest.FromString,
                    response_serializer=minknow__api_dot_minion__device__pb2.ChangeSettingsResponse.SerializeToString,
            ),
            'get_settings': grpc.unary_unary_rpc_method_handler(
                    servicer.get_settings,
                    request_deserializer=minknow__api_dot_minion__device__pb2.GetSettingsRequest.FromString,
                    response_serializer=minknow__api_dot_minion__device__pb2.GetSettingsResponse.SerializeToString,
            ),
            'get_fan_speed': grpc.unary_unary_rpc_method_handler(
                    servicer.get_fan_speed,
                    request_deserializer=minknow__api_dot_minion__device__pb2.GetFanSpeedRequest.FromString,
                    response_serializer=minknow__api_dot_minion__device__pb2.GetFanSpeedResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'minknow_api.minion_device.MinionDeviceService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class MinionDeviceService(object):
    """Interface to control MinION (and MinION-like) devices.
    """

    @staticmethod
    def change_settings(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/minknow_api.minion_device.MinionDeviceService/change_settings',
            minknow__api_dot_minion__device__pb2.ChangeSettingsRequest.SerializeToString,
            minknow__api_dot_minion__device__pb2.ChangeSettingsResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def get_settings(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/minknow_api.minion_device.MinionDeviceService/get_settings',
            minknow__api_dot_minion__device__pb2.GetSettingsRequest.SerializeToString,
            minknow__api_dot_minion__device__pb2.GetSettingsResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def get_fan_speed(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/minknow_api.minion_device.MinionDeviceService/get_fan_speed',
            minknow__api_dot_minion__device__pb2.GetFanSpeedRequest.SerializeToString,
            minknow__api_dot_minion__device__pb2.GetFanSpeedResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
